﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.windows;
using ModbusDemo.Modular;
namespace ModbusDemo.application
{
    public class AutoControl
    {
        //Automatic Control Enablation
        //Startcontrol MAX
        //stopcontrol  Min
        //modbuspolling ——water level
        //工作状态
        public class Status
        {
            public bool Beyond_the_limit; //超出极限值
            public bool normal;//正常·工作中
            public bool Minimum_Early_Warning;//低值预警
        }
        public class Control : Status
        {
            public bool Enablation;
            public float maxLevel;
            public float minLevel;
            public float DifferenceValue;
            public double realTimeLevel;
            public bool status;
            public string Name;
            public double StatusTime;
        }

        public static void CriticalValueMonitoring(
            bool Enabl, double MaxLevel,
            double MinLevel, double ActualValue,
            string Affiliation, out Control control)
        {
            System.Diagnostics.Stopwatch stopwatch = new System.Diagnostics.Stopwatch();
            Control usControl = new Control
            {
                Enablation = Enabl,
                realTimeLevel = ActualValue,
                Name = Affiliation
            };
            if (usControl.Enablation == true)
            {
                if (MaxLevel != 0.0 && MinLevel != 0.0)
                {
                    InIHelper.WriteConfig("MaxLevel", Affiliation, MaxLevel.ToString());
                    InIHelper.WriteConfig("MinLevel", Affiliation, MinLevel.ToString());
                    usControl.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", Affiliation);
                    usControl.minLevel = InIHelper.ReadConfig<float>("MinLevel", Affiliation);
                }
                else
                {
                    usControl.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", Affiliation);
                    usControl.minLevel = InIHelper.ReadConfig<float>("MinLevel", Affiliation);
                }
                usControl.realTimeLevel = Meanfilter(usControl.realTimeLevel);//实时值

                usControl.DifferenceValue = usControl.maxLevel - usControl.minLevel;//极值差

                if (usControl.realTimeLevel > usControl.maxLevel)
                {
                    usControl.status = true;
                    usControl.Beyond_the_limit = true;
                }
                else if (usControl.realTimeLevel < usControl.maxLevel && usControl.realTimeLevel > (usControl.minLevel + usControl.minLevel * 0.15))
                {
                    usControl.status = true;
                    usControl.normal = true;
                }

                if (usControl.realTimeLevel < (usControl.minLevel - usControl.minLevel * 0.1))
                {
                    usControl.status = false;
                    usControl.Minimum_Early_Warning = true;
                }
                if (usControl.status == true)
                {
                    stopwatch.Start(); //  开始监视运行时间
                }
                else
                {
                    stopwatch.Stop(); //  停止监视
                }
                TimeSpan timespan = stopwatch.Elapsed; //  获取当前实例测量得出的总时间
                //double hours = timespan.TotalHours; // 总小时
                usControl.StatusTime = timespan.TotalMinutes;  // 总分钟
                //usControl.StatusTime = timespan.TotalSeconds;  //  总秒数
                usControl.StatusTime = timespan.TotalMilliseconds;  //  总毫秒数

            }
            control = usControl;
        }
        public static double Meanfilter(double Value)
        {
            double[] MeanValue = new double[10];
            for (int i = 0; i < 10; i++)
            {
                MeanValue[i] = Value;
            }
            Value = MeanValue[0] * 0.1 + MeanValue[5] * 0.3 + MeanValue[9] * 0.6;
            return Value;
        }
    }
}
